/* 1-26-98 */

/* redundant include protection */

#ifndef _IMAGE_H_
#define _IMAGE_H_


/* constants */

#define IMG_FTYPE_NONE 0
#define IMG_FTYPE_GIF  1
#define IMG_FTYPE_PGM  2
#define IMG_FTYPE_PPM  3
#define IMG_FTYPE_JPEG 4

/*** Type Definitions ***/

typedef unsigned char pix_val_t;
typedef unsigned long img_dim_t;

typedef struct {
  char      *name;
  int        chan_cnt;
  img_dim_t  width, height, stride;
  pix_val_t *data;
  int        ftype;
} img_t;

typedef struct {
  int     cnt;
  img_t **image;
  char  **fname;
} img_list_t;

typedef struct {
  int        size;	/* number of entries in the color map */
  int        chan_cnt;	/* number of channels 1 or 3 */
  pix_val_t *data;	/* interlaced (rgb, rgb, ...) look up table */
  pix_val_t *used;	/* flags indicating which entries in
			 * the color map were used */
} colormap_t;

/*** Macro Definitions ***/

#define ROWS(img)  ((img)->height)
#define COLS(img)  ((img)->width)
#define NAME(img)  ((img)->name)


/*** Function Prototypes ***/

img_t *img_new();
img_t *img_create (char *name, img_dim_t wd, img_dim_t ht, int chan_cnt);
void img_free (img_t *img);
void img_setpixel_rc (img_t *img, img_dim_t y, img_dim_t x, pix_val_t val);
pix_val_t img_getpixel_rc (img_t *img, img_dim_t y, img_dim_t x);
img_list_t *imgl_new();
int imgl_add (img_list_t *il, char *fname, img_t *img);
void imgl_free();
char *img_basename (char *filename);
char *imgl_clean_str (char *str);
img_list_t *imgl_load_list (char *filename);
void img_fill (img_t *img, pix_val_t *color);
colormap_t *img_colormap_alloc (int size, int chan_cnt);
void img_colormap_free (colormap_t *cmap);
int img_colormap_find (colormap_t *cmap, pix_val_t *color);
int img_colormap_calc_used (colormap_t *cmap, img_t *img);
int img_colormap_check_used_bilevel (colormap_t *cmap);
img_t *img_dup (img_t *src_img);
img_t *img_create_basis (img_t *src, img_dim_t wd, img_dim_t ht, int chan_cnt);

#endif

