/*%********************************************************************
 *
 * File: img_util.h
 *
 * Author:  Charles Rosenberg 
 * Created: May 11, 1997
 * 
 * Header file for img_util.c
 *
 * General purpose utilities for image processing.
 *
 * Modification History
 *
 * 05/11/98, cjr: Created.
 *
 **********************************************************************
 */


/* constants */

/* data types */


/* function prototypes */

img_t *img_simple_high_pass (img_t *src_img);
void img_simple_stretch (img_t *img);
void img_simple_normalize (img_t *img, int range);
int get_img_filetype (char *filename);
img_t *img_read_file (char *filename);
int get_img_fname_filetype (char *filename);
void img_hist_eq (img_t *img);
void img_hist_range_adjust (img_t *img, int chan_flag);
void img_hist_range_adjust2 (img_t *img);
void img_hist_range_adjust2_white_only (img_t *img);
void img_hist_eq2 (img_t *img);
img_t *img_process (img_t *image, int ip_mode);
img_t *img_process_args (img_t *image, int ip_mode, double *args);
void ip_help (FILE *stream, char *indent);
img_t *img_crop (img_t *img, 
		 img_dim_t x_start, img_dim_t y_start,
		 img_dim_t x_end, img_dim_t y_end);
img_t *img_pad (img_t *img, 
		img_dim_t new_width, img_dim_t new_height,
		pix_val_t *background);
void img_blit (img_t *dest_img, img_t *src_img,
	       img_dim_t x_start, img_dim_t y_start);
void img_hist_range_adjust3 (img_t *img);
void img_hist_range_adjust3_white_only (img_t *img);

void img_hist_range_adjust4 (img_t *img);
void img_hist_range_adjust4_white_only (img_t *img);
void img_hist_range_adjust4_simple_black (img_t *img);
void img_hist_range_adjust4_var_black (img_t *img);
void img_hist_range_adjust4_mix0 (img_t *img);
void img_hist_range_adjust4_mix1 (img_t *img);
void img_hist_range_adjust4_mix2 (img_t *img);
void img_hist_range_adjust4_fast (img_t *img);
void img_hist_range_adjust4_fast_mix0 (img_t *img);
void img_hist_range_adjust4_fast_nofix (img_t *img);

void img_hist_range_adjust5 (img_t *img);
void img_hist_range_adjust5_white_only (img_t *img);

void img_hist_range_adjust6 (img_t *img);
void img_hist_range_adjust6_fast (img_t *img);
void img_hist_quant_adjust6 (img_t *img);
void img_hist_quant_adjust6_fast (img_t *img);

void img_mean_scale (img_t *img, int new_mean);

void img_nybble_swap (img_t *img);

img_t *img_simple_sharpen (img_t *src_img, double weight);
img_t *img_simple_sharpen_bound (img_t *src_img, double weight);

img_t *img_simple_rotate (img_t *src_img, int angle);

void img_apply_gamma (img_t *img, double gamma);

img_t *img_trim_borders (img_t *src_img, pix_val_t thresh, int above_flag,
			 int border_width, int cnt_thresh);

